'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Node2 = require('./Node.js');

var _Node3 = _interopRequireDefault(_Node2);

var _Scope = require('./Scope.js');

var _Scope2 = _interopRequireDefault(_Scope);

var _destructure = require('../utils/destructure.js');

var _destructure2 = _interopRequireDefault(_destructure);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function isUseStrict(node) {
	if (!node) return false;
	if (node.type !== 'ExpressionStatement') return false;
	if (node.expression.type !== 'Literal') return false;
	return node.expression.value === 'use strict';
}

var BlockStatement = function (_Node) {
	_inherits(BlockStatement, _Node);

	function BlockStatement() {
		_classCallCheck(this, BlockStatement);

		return _possibleConstructorReturn(this, (BlockStatement.__proto__ || Object.getPrototypeOf(BlockStatement)).apply(this, arguments));
	}

	_createClass(BlockStatement, [{
		key: 'createScope',
		value: function createScope() {
			var _this2 = this;

			this.parentIsFunction = /Function/.test(this.parent.type);
			this.isFunctionBlock = this.parentIsFunction || this.parent.type === 'Root';
			this.scope = new _Scope2.default({
				block: !this.isFunctionBlock,
				parent: this.parent.findScope(false),
				declare: function declare(id) {
					return _this2.createdDeclarations.push(id);
				}
			});

			if (this.parentIsFunction) {
				this.parent.params.forEach(function (node) {
					_this2.scope.addDeclaration(node, 'param');
				});
			}
		}
	}, {
		key: 'initialise',
		value: function initialise(transforms) {
			this.thisAlias = null;
			this.argumentsAlias = null;
			this.defaultParameters = [];
			this.createdDeclarations = [];

			// normally the scope gets created here, during initialisation,
			// but in some cases (e.g. `for` statements), we need to create
			// the scope early, as it pertains to both the init block and
			// the body of the statement
			if (!this.scope) this.createScope();

			this.body.forEach(function (node) {
				return node.initialise(transforms);
			});

			this.scope.consolidate();
		}
	}, {
		key: 'findLexicalBoundary',
		value: function findLexicalBoundary() {
			if (this.type === 'Program') return this;
			if (/^Function/.test(this.parent.type)) return this;

			return this.parent.findLexicalBoundary();
		}
	}, {
		key: 'findScope',
		value: function findScope(functionScope) {
			if (functionScope && !this.isFunctionBlock) return this.parent.findScope(functionScope);
			return this.scope;
		}
	}, {
		key: 'getArgumentsAlias',
		value: function getArgumentsAlias() {
			if (!this.argumentsAlias) {
				this.argumentsAlias = this.scope.createIdentifier('arguments');
			}

			return this.argumentsAlias;
		}
	}, {
		key: 'getArgumentsArrayAlias',
		value: function getArgumentsArrayAlias() {
			if (!this.argumentsArrayAlias) {
				this.argumentsArrayAlias = this.scope.createIdentifier('argsArray');
			}

			return this.argumentsArrayAlias;
		}
	}, {
		key: 'getThisAlias',
		value: function getThisAlias() {
			if (!this.thisAlias) {
				this.thisAlias = this.scope.createIdentifier('this');
			}

			return this.thisAlias;
		}
	}, {
		key: 'getIndentation',
		value: function getIndentation() {
			if (this.indentation === undefined) {
				var source = this.program.magicString.original;

				var useOuter = this.synthetic || !this.body.length;
				var c = useOuter ? this.start : this.body[0].start;

				while (c && source[c] !== '\n') {
					c -= 1;
				}this.indentation = '';

				// eslint-disable-next-line no-constant-condition
				while (true) {
					c += 1;
					var char = source[c];

					if (char !== ' ' && char !== '\t') break;

					this.indentation += char;
				}

				var indentString = this.program.magicString.getIndentString();

				// account for dedented class constructors
				var parent = this.parent;
				while (parent) {
					if (parent.kind === 'constructor' && !parent.parent.parent.superClass) {
						this.indentation = this.indentation.replace(indentString, '');
					}

					parent = parent.parent;
				}

				if (useOuter) this.indentation += indentString;
			}

			return this.indentation;
		}
	}, {
		key: 'transpile',
		value: function transpile(code, transforms) {
			var _this3 = this;

			var indentation = this.getIndentation();

			var introStatementGenerators = [];

			if (this.argumentsAlias) {
				introStatementGenerators.push(function (start, prefix, suffix) {
					var assignment = prefix + 'var ' + _this3.argumentsAlias + ' = arguments' + suffix;
					code.appendLeft(start, assignment);
				});
			}

			if (this.thisAlias) {
				introStatementGenerators.push(function (start, prefix, suffix) {
					var assignment = prefix + 'var ' + _this3.thisAlias + ' = this' + suffix;
					code.appendLeft(start, assignment);
				});
			}

			if (this.argumentsArrayAlias) {
				introStatementGenerators.push(function (start, prefix, suffix) {
					var i = _this3.scope.createIdentifier('i');
					var assignment = prefix + 'var ' + i + ' = arguments.length, ' + _this3.argumentsArrayAlias + ' = Array(' + i + ');\n' + indentation + 'while ( ' + i + '-- ) ' + _this3.argumentsArrayAlias + '[' + i + '] = arguments[' + i + ']' + suffix;
					code.appendLeft(start, assignment);
				});
			}

			if (/Function/.test(this.parent.type)) {
				this.transpileParameters(this.parent.params, code, transforms, indentation, introStatementGenerators);
			} else if ('CatchClause' === this.parent.type) {
				this.transpileParameters([this.parent.param], code, transforms, indentation, introStatementGenerators);
			}

			if (transforms.letConst && this.isFunctionBlock) {
				this.transpileBlockScopedIdentifiers(code);
			}

			_get(BlockStatement.prototype.__proto__ || Object.getPrototypeOf(BlockStatement.prototype), 'transpile', this).call(this, code, transforms);

			if (this.createdDeclarations.length) {
				introStatementGenerators.push(function (start, prefix, suffix) {
					var assignment = prefix + 'var ' + _this3.createdDeclarations.join(', ') + suffix;
					code.appendLeft(start, assignment);
				});
			}

			if (this.synthetic) {
				if (this.parent.type === 'ArrowFunctionExpression') {
					var expr = this.body[0];

					if (introStatementGenerators.length) {
						code.appendLeft(this.start, '{').prependRight(this.end, this.parent.getIndentation() + '}');

						code.prependRight(expr.start, '\n' + indentation + 'return ');
						code.appendLeft(expr.end, ';\n');
					} else if (transforms.arrow) {
						code.prependRight(expr.start, '{ return ');
						code.appendLeft(expr.end, '; }');
					}
				} else if (introStatementGenerators.length) {
					code.prependRight(this.start, '{').appendLeft(this.end, '}');
				}
			}

			var start = void 0;
			if (isUseStrict(this.body[0])) {
				start = this.body[0].end;
			} else if (this.synthetic || this.parent.type === 'Root') {
				start = this.start;
			} else {
				start = this.start + 1;
			}

			var prefix = '\n' + indentation;
			var suffix = ';';
			introStatementGenerators.forEach(function (fn, i) {
				if (i === introStatementGenerators.length - 1) suffix = ';\n';
				fn(start, prefix, suffix);
			});
		}
	}, {
		key: 'transpileParameters',
		value: function transpileParameters(params, code, transforms, indentation, introStatementGenerators) {
			var _this4 = this;

			params.forEach(function (param) {
				if (param.type === 'AssignmentPattern' && param.left.type === 'Identifier') {
					if (transforms.defaultParameter) {
						introStatementGenerators.push(function (start, prefix, suffix) {
							var lhs = prefix + 'if ( ' + param.left.name + ' === void 0 ) ' + param.left.name;

							code.prependRight(param.left.end, lhs).move(param.left.end, param.right.end, start).appendLeft(param.right.end, suffix);
						});
					}
				} else if (param.type === 'RestElement') {
					if (transforms.spreadRest) {
						introStatementGenerators.push(function (start, prefix, suffix) {
							var penultimateParam = params[params.length - 2];

							if (penultimateParam) {
								code.remove(penultimateParam ? penultimateParam.end : param.start, param.end);
							} else {
								var _start = param.start,
								    end = param.end; // TODO https://gitlab.com/Rich-Harris/buble/issues/8

								while (/\s/.test(code.original[_start - 1])) {
									_start -= 1;
								}while (/\s/.test(code.original[end])) {
									end += 1;
								}code.remove(_start, end);
							}

							var name = param.argument.name;
							var len = _this4.scope.createIdentifier('len');
							var count = params.length - 1;

							if (count) {
								code.prependRight(start, prefix + 'var ' + name + ' = [], ' + len + ' = arguments.length - ' + count + ';\n' + indentation + 'while ( ' + len + '-- > 0 ) ' + name + '[ ' + len + ' ] = arguments[ ' + len + ' + ' + count + ' ]' + suffix);
							} else {
								code.prependRight(start, prefix + 'var ' + name + ' = [], ' + len + ' = arguments.length;\n' + indentation + 'while ( ' + len + '-- ) ' + name + '[ ' + len + ' ] = arguments[ ' + len + ' ]' + suffix);
							}
						});
					}
				} else if (param.type !== 'Identifier') {
					if (transforms.parameterDestructuring) {
						var ref = _this4.scope.createIdentifier('ref');
						(0, _destructure2.default)(code, function (id) {
							return _this4.scope.createIdentifier(id);
						}, function (_ref) {
							var name = _ref.name;
							return _this4.scope.resolveName(name);
						}, param, ref, false, introStatementGenerators);
						code.prependRight(param.start, ref);
					}
				}
			});
		}
	}, {
		key: 'transpileBlockScopedIdentifiers',
		value: function transpileBlockScopedIdentifiers(code) {
			var _this5 = this;

			Object.keys(this.scope.blockScopedDeclarations).forEach(function (name) {
				var declarations = _this5.scope.blockScopedDeclarations[name];

				var _iteratorNormalCompletion = true;
				var _didIteratorError = false;
				var _iteratorError = undefined;

				try {
					for (var _iterator = declarations[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
						var declaration = _step.value;

						var cont = false; // TODO implement proper continue...

						if (declaration.kind === 'for.let') {
							// special case
							var forStatement = declaration.node.findNearest('ForStatement');

							if (forStatement.shouldRewriteAsFunction) {
								var outerAlias = _this5.scope.createIdentifier(name);
								var innerAlias = forStatement.reassigned[name] ? _this5.scope.createIdentifier(name) : name;

								declaration.name = outerAlias;
								code.overwrite(declaration.node.start, declaration.node.end, outerAlias, { storeName: true });

								forStatement.aliases[name] = {
									outer: outerAlias,
									inner: innerAlias
								};

								var _iteratorNormalCompletion2 = true;
								var _didIteratorError2 = false;
								var _iteratorError2 = undefined;

								try {
									for (var _iterator2 = declaration.instances[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
										var identifier = _step2.value;

										var alias = forStatement.body.contains(identifier) ? innerAlias : outerAlias;

										if (name !== alias) {
											code.overwrite(identifier.start, identifier.end, alias, {
												storeName: true
											});
										}
									}
								} catch (err) {
									_didIteratorError2 = true;
									_iteratorError2 = err;
								} finally {
									try {
										if (!_iteratorNormalCompletion2 && _iterator2.return) {
											_iterator2.return();
										}
									} finally {
										if (_didIteratorError2) {
											throw _iteratorError2;
										}
									}
								}

								cont = true;
							}
						}

						if (!cont) {
							var _alias = _this5.scope.createIdentifier(name);

							if (name !== _alias) {
								declaration.name = _alias;
								code.overwrite(declaration.node.start, declaration.node.end, _alias, { storeName: true });

								var _iteratorNormalCompletion3 = true;
								var _didIteratorError3 = false;
								var _iteratorError3 = undefined;

								try {
									for (var _iterator3 = declaration.instances[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
										var _identifier = _step3.value;

										_identifier.rewritten = true;
										code.overwrite(_identifier.start, _identifier.end, _alias, {
											storeName: true
										});
									}
								} catch (err) {
									_didIteratorError3 = true;
									_iteratorError3 = err;
								} finally {
									try {
										if (!_iteratorNormalCompletion3 && _iterator3.return) {
											_iterator3.return();
										}
									} finally {
										if (_didIteratorError3) {
											throw _iteratorError3;
										}
									}
								}
							}
						}
					}
				} catch (err) {
					_didIteratorError = true;
					_iteratorError = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion && _iterator.return) {
							_iterator.return();
						}
					} finally {
						if (_didIteratorError) {
							throw _iteratorError;
						}
					}
				}
			});
		}
	}]);

	return BlockStatement;
}(_Node3.default);

exports.default = BlockStatement;