'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// used for debugging, without the noise created by
// circular references
function _toJSON(node) {
	var obj = {};

	Object.keys(node).forEach(function (key) {
		if (key === 'parent' || key === 'program' || key === 'keys' || key === '__wrapped') return;

		if (Array.isArray(node[key])) {
			obj[key] = node[key].map(_toJSON);
		} else if (node[key] && node[key].toJSON) {
			obj[key] = node[key].toJSON();
		} else {
			obj[key] = node[key];
		}
	});

	return obj;
}

var Node = function () {
	function Node() {
		_classCallCheck(this, Node);
	}

	_createClass(Node, [{
		key: 'ancestor',
		value: function ancestor(level) {
			var node = this;
			while (level--) {
				node = node.parent;
				if (!node) return null;
			}

			return node;
		}
	}, {
		key: 'contains',
		value: function contains(node) {
			while (node) {
				if (node === this) return true;
				node = node.parent;
			}

			return false;
		}
	}, {
		key: 'findLexicalBoundary',
		value: function findLexicalBoundary() {
			return this.parent.findLexicalBoundary();
		}
	}, {
		key: 'findNearest',
		value: function findNearest(type) {
			if (typeof type === 'string') type = new RegExp('^' + type + '$');
			if (type.test(this.type)) return this;
			return this.parent.findNearest(type);
		}
	}, {
		key: 'unparenthesizedParent',
		value: function unparenthesizedParent() {
			var node = this.parent;
			while (node && node.type === 'ParenthesizedExpression') {
				node = node.parent;
			}
			return node;
		}
	}, {
		key: 'unparenthesize',
		value: function unparenthesize() {
			var node = this;
			while (node.type === 'ParenthesizedExpression') {
				node = node.expression;
			}
			return node;
		}
	}, {
		key: 'findScope',
		value: function findScope(functionScope) {
			return this.parent.findScope(functionScope);
		}
	}, {
		key: 'getIndentation',
		value: function getIndentation() {
			return this.parent.getIndentation();
		}
	}, {
		key: 'initialise',
		value: function initialise(transforms) {
			var _iteratorNormalCompletion = true;
			var _didIteratorError = false;
			var _iteratorError = undefined;

			try {
				for (var _iterator = this.keys[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
					var key = _step.value;

					var value = this[key];

					if (Array.isArray(value)) {
						value.forEach(function (node) {
							return node && node.initialise(transforms);
						});
					} else if (value && (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') {
						value.initialise(transforms);
					}
				}
			} catch (err) {
				_didIteratorError = true;
				_iteratorError = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion && _iterator.return) {
						_iterator.return();
					}
				} finally {
					if (_didIteratorError) {
						throw _iteratorError;
					}
				}
			}
		}
	}, {
		key: 'toJSON',
		value: function toJSON() {
			return _toJSON(this);
		}
	}, {
		key: 'toString',
		value: function toString() {
			return this.program.magicString.original.slice(this.start, this.end);
		}
	}, {
		key: 'transpile',
		value: function transpile(code, transforms) {
			var _iteratorNormalCompletion2 = true;
			var _didIteratorError2 = false;
			var _iteratorError2 = undefined;

			try {
				for (var _iterator2 = this.keys[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
					var key = _step2.value;

					var value = this[key];

					if (Array.isArray(value)) {
						value.forEach(function (node) {
							return node && node.transpile(code, transforms);
						});
					} else if (value && (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') {
						value.transpile(code, transforms);
					}
				}
			} catch (err) {
				_didIteratorError2 = true;
				_iteratorError2 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion2 && _iterator2.return) {
						_iterator2.return();
					}
				} finally {
					if (_didIteratorError2) {
						throw _iteratorError2;
					}
				}
			}
		}
	}]);

	return Node;
}();

exports.default = Node;