'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = Program;

var _magicString = require('magic-string');

var _magicString2 = _interopRequireDefault(_magicString);

var _BlockStatement = require('./BlockStatement.js');

var _BlockStatement2 = _interopRequireDefault(_BlockStatement);

var _wrap = require('./wrap.js');

var _wrap2 = _interopRequireDefault(_wrap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Program(source, ast, transforms, options) {
	this.type = 'Root';

	// options
	this.jsx = options.jsx || 'React.createElement';
	this.options = options;

	this.source = source;
	this.magicString = new _magicString2.default(source);

	this.ast = ast;
	this.depth = 0;

	(0, _wrap2.default)(this.body = ast, this);
	this.body.__proto__ = _BlockStatement2.default.prototype;

	this.templateLiteralQuasis = Object.create(null);
	for (var i = 0; i < this.body.body.length; ++i) {
		if (!this.body.body[i].directive) {
			this.prependAt = this.body.body[i].start;
			break;
		}
	}
	this.objectWithoutPropertiesHelper = null;

	this.indentExclusionElements = [];
	this.body.initialise(transforms);

	this.indentExclusions = Object.create(null);
	var _iteratorNormalCompletion = true;
	var _didIteratorError = false;
	var _iteratorError = undefined;

	try {
		for (var _iterator = this.indentExclusionElements[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
			var node = _step.value;

			for (var _i = node.start; _i < node.end; _i += 1) {
				this.indentExclusions[_i] = true;
			}
		}
	} catch (err) {
		_didIteratorError = true;
		_iteratorError = err;
	} finally {
		try {
			if (!_iteratorNormalCompletion && _iterator.return) {
				_iterator.return();
			}
		} finally {
			if (_didIteratorError) {
				throw _iteratorError;
			}
		}
	}

	this.body.transpile(this.magicString, transforms);
}

Program.prototype = {
	export: function _export() {
		var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		return {
			code: this.magicString.toString(),
			map: this.magicString.generateMap({
				file: options.file,
				source: options.source,
				includeContent: options.includeContent !== false
			})
		};
	},
	findNearest: function findNearest() {
		return null;
	},
	findScope: function findScope() {
		return null;
	},
	getObjectWithoutPropertiesHelper: function getObjectWithoutPropertiesHelper(code) {
		if (!this.objectWithoutPropertiesHelper) {
			this.objectWithoutPropertiesHelper = this.body.scope.createIdentifier('objectWithoutProperties');
			code.prependLeft(this.prependAt, 'function ' + this.objectWithoutPropertiesHelper + ' (obj, exclude) { ' + 'var target = {}; for (var k in obj) ' + 'if (Object.prototype.hasOwnProperty.call(obj, k) && exclude.indexOf(k) === -1) ' + 'target[k] = obj[k]; return target; }\n');
		}
		return this.objectWithoutPropertiesHelper;
	}
};