'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

var _checkConst = require('../../utils/checkConst.js');

var _checkConst2 = _interopRequireDefault(_checkConst);

var _destructure = require('../../utils/destructure.js');

var _destructure2 = _interopRequireDefault(_destructure);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AssignmentExpression = function (_Node) {
	_inherits(AssignmentExpression, _Node);

	function AssignmentExpression() {
		_classCallCheck(this, AssignmentExpression);

		return _possibleConstructorReturn(this, (AssignmentExpression.__proto__ || Object.getPrototypeOf(AssignmentExpression)).apply(this, arguments));
	}

	_createClass(AssignmentExpression, [{
		key: 'initialise',
		value: function initialise(transforms) {
			if (this.left.type === 'Identifier') {
				var declaration = this.findScope(false).findDeclaration(this.left.name);
				// special case – https://gitlab.com/Rich-Harris/buble/issues/11
				var statement = declaration && declaration.node.ancestor(3);
				if (statement && statement.type === 'ForStatement' && statement.body.contains(this)) {
					statement.reassigned[this.left.name] = true;
				}
			}

			_get(AssignmentExpression.prototype.__proto__ || Object.getPrototypeOf(AssignmentExpression.prototype), 'initialise', this).call(this, transforms);
		}
	}, {
		key: 'transpile',
		value: function transpile(code, transforms) {
			if (this.left.type === 'Identifier') {
				// Do this check after everything has been initialized to find
				// shadowing declarations after this expression
				(0, _checkConst2.default)(this.left, this.findScope(false));
			}

			if (this.operator === '**=' && transforms.exponentiation) {
				this.transpileExponentiation(code, transforms);
			} else if (/Pattern/.test(this.left.type) && transforms.destructuring) {
				this.transpileDestructuring(code, transforms);
			}

			_get(AssignmentExpression.prototype.__proto__ || Object.getPrototypeOf(AssignmentExpression.prototype), 'transpile', this).call(this, code, transforms);
		}
	}, {
		key: 'transpileDestructuring',
		value: function transpileDestructuring(code) {
			var _this2 = this;

			var writeScope = this.findScope(true);
			var lookupScope = this.findScope(false);
			var assign = writeScope.createDeclaration('assign');
			code.appendRight(this.left.end, '(' + assign);

			code.appendLeft(this.right.end, ', ');
			var statementGenerators = [];
			(0, _destructure2.default)(code, function (id) {
				return writeScope.createDeclaration(id);
			}, function (node) {
				var name = lookupScope.resolveName(node.name);
				(0, _checkConst2.default)(node, lookupScope);
				return name;
			}, this.left, assign, true, statementGenerators);

			var suffix = ', ';
			statementGenerators.forEach(function (fn, j) {
				if (j === statementGenerators.length - 1) {
					suffix = '';
				}

				fn(_this2.end, '', suffix);
			});

			if (this.unparenthesizedParent().type === 'ExpressionStatement') {
				// no rvalue needed for expression statement
				code.prependRight(this.end, ')');
			} else {
				// destructuring is part of an expression - need an rvalue
				code.appendRight(this.end, ', ' + assign + ')');
			}
		}
	}, {
		key: 'transpileExponentiation',
		value: function transpileExponentiation(code) {
			var scope = this.findScope(false);

			// first, the easy part – `**=` -> `=`
			var charIndex = this.left.end;
			while (code.original[charIndex] !== '*') {
				charIndex += 1;
			}code.remove(charIndex, charIndex + 2);

			// how we do the next part depends on a number of factors – whether
			// this is a top-level statement, and whether we're updating a
			// simple or complex reference
			var base = void 0;

			var left = this.left.unparenthesize();

			if (left.type === 'Identifier') {
				base = scope.resolveName(left.name);
			} else if (left.type === 'MemberExpression') {
				var object = void 0;
				var needsObjectVar = false;
				var property = void 0;
				var needsPropertyVar = false;

				var statement = this.findNearest(/(?:Statement|Declaration)$/);
				var i0 = statement.getIndentation();

				if (left.property.type === 'Identifier') {
					property = left.computed ? scope.resolveName(left.property.name) : left.property.name;
				} else {
					property = scope.createDeclaration('property');
					needsPropertyVar = true;
				}

				if (left.object.type === 'Identifier') {
					object = scope.resolveName(left.object.name);
				} else {
					object = scope.createDeclaration('object');
					needsObjectVar = true;
				}

				if (left.start === statement.start) {
					if (needsObjectVar && needsPropertyVar) {
						code.prependRight(statement.start, object + ' = ');
						code.overwrite(left.object.end, left.property.start, ';\n' + i0 + property + ' = ');
						code.overwrite(left.property.end, left.end, ';\n' + i0 + object + '[' + property + ']');
					} else if (needsObjectVar) {
						code.prependRight(statement.start, object + ' = ');
						code.appendLeft(left.object.end, ';\n' + i0);
						code.appendLeft(left.object.end, object);
					} else if (needsPropertyVar) {
						code.prependRight(left.property.start, property + ' = ');
						code.appendLeft(left.property.end, ';\n' + i0);
						code.move(left.property.start, left.property.end, this.start);

						code.appendLeft(left.object.end, '[' + property + ']');
						code.remove(left.object.end, left.property.start);
						code.remove(left.property.end, left.end);
					}
				} else {
					if (needsObjectVar && needsPropertyVar) {
						code.prependRight(left.start, '( ' + object + ' = ');
						code.overwrite(left.object.end, left.property.start, ', ' + property + ' = ');
						code.overwrite(left.property.end, left.end, ', ' + object + '[' + property + ']');
					} else if (needsObjectVar) {
						code.prependRight(left.start, '( ' + object + ' = ');
						code.appendLeft(left.object.end, ', ' + object);
					} else if (needsPropertyVar) {
						code.prependRight(left.property.start, '( ' + property + ' = ');
						code.appendLeft(left.property.end, ', ');
						code.move(left.property.start, left.property.end, left.start);

						code.overwrite(left.object.end, left.property.start, '[' + property + ']');
						code.remove(left.property.end, left.end);
					}

					if (needsPropertyVar) {
						code.appendLeft(this.end, ' )');
					}
				}

				base = object + (left.computed || needsPropertyVar ? '[' + property + ']' : '.' + property);
			}

			code.prependRight(this.right.start, 'Math.pow( ' + base + ', ');
			code.appendLeft(this.right.end, ' )');
		}
	}]);

	return AssignmentExpression;
}(_Node3.default);

exports.default = AssignmentExpression;