'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _LoopStatement2 = require('./shared/LoopStatement.js');

var _LoopStatement3 = _interopRequireDefault(_LoopStatement2);

var _destructure = require('../../utils/destructure.js');

var _destructure2 = _interopRequireDefault(_destructure);

var _extractNames = require('../extractNames.js');

var _extractNames2 = _interopRequireDefault(_extractNames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ForInStatement = function (_LoopStatement) {
	_inherits(ForInStatement, _LoopStatement);

	function ForInStatement() {
		_classCallCheck(this, ForInStatement);

		return _possibleConstructorReturn(this, (ForInStatement.__proto__ || Object.getPrototypeOf(ForInStatement)).apply(this, arguments));
	}

	_createClass(ForInStatement, [{
		key: 'findScope',
		value: function findScope(functionScope) {
			return functionScope || !this.createdScope ? this.parent.findScope(functionScope) : this.body.scope;
		}
	}, {
		key: 'transpile',
		value: function transpile(code, transforms) {
			var _this2 = this;

			var hasDeclaration = this.left.type === 'VariableDeclaration';

			if (this.shouldRewriteAsFunction) {
				// which variables are declared in the init statement?
				var names = hasDeclaration ? this.left.declarations.map(function (declarator) {
					return (0, _extractNames2.default)(declarator.id);
				}) : [];

				this.args = names.map(function (name) {
					return name in _this2.aliases ? _this2.aliases[name].outer : name;
				});
				this.params = names.map(function (name) {
					return name in _this2.aliases ? _this2.aliases[name].inner : name;
				});
			}

			_get(ForInStatement.prototype.__proto__ || Object.getPrototypeOf(ForInStatement.prototype), 'transpile', this).call(this, code, transforms);

			var maybePattern = hasDeclaration ? this.left.declarations[0].id : this.left;
			if (maybePattern.type !== 'Identifier') {
				this.destructurePattern(code, maybePattern, hasDeclaration);
			}
		}
	}, {
		key: 'destructurePattern',
		value: function destructurePattern(code, pattern, isDeclaration) {
			var scope = this.findScope(true);
			var i0 = this.getIndentation();
			var i1 = i0 + code.getIndentString();

			var ref = scope.createIdentifier('ref');

			var bodyStart = this.body.body.length ? this.body.body[0].start : this.body.start + 1;

			code.move(pattern.start, pattern.end, bodyStart);

			code.prependRight(pattern.end, isDeclaration ? ref : 'var ' + ref);

			var statementGenerators = [];
			(0, _destructure2.default)(code, function (id) {
				return scope.createIdentifier(id);
			}, function (_ref) {
				var name = _ref.name;
				return scope.resolveName(name);
			}, pattern, ref, false, statementGenerators);

			var suffix = ';\n' + i1;
			statementGenerators.forEach(function (fn, i) {
				if (i === statementGenerators.length - 1) {
					suffix = ';\n\n' + i1;
				}

				fn(bodyStart, '', suffix);
			});
		}
	}]);

	return ForInStatement;
}(_LoopStatement3.default);

exports.default = ForInStatement;