'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _LoopStatement2 = require('./shared/LoopStatement.js');

var _LoopStatement3 = _interopRequireDefault(_LoopStatement2);

var _CompileError = require('../../utils/CompileError.js');

var _CompileError2 = _interopRequireDefault(_CompileError);

var _destructure = require('../../utils/destructure.js');

var _destructure2 = _interopRequireDefault(_destructure);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ForOfStatement = function (_LoopStatement) {
	_inherits(ForOfStatement, _LoopStatement);

	function ForOfStatement() {
		_classCallCheck(this, ForOfStatement);

		return _possibleConstructorReturn(this, (ForOfStatement.__proto__ || Object.getPrototypeOf(ForOfStatement)).apply(this, arguments));
	}

	_createClass(ForOfStatement, [{
		key: 'initialise',
		value: function initialise(transforms) {
			if (transforms.forOf && !transforms.dangerousForOf) throw new _CompileError2.default("for...of statements are not supported. Use `transforms: { forOf: false }` to skip transformation and disable this error, or `transforms: { dangerousForOf: true }` if you know what you're doing", this);
			_get(ForOfStatement.prototype.__proto__ || Object.getPrototypeOf(ForOfStatement.prototype), 'initialise', this).call(this, transforms);
		}
	}, {
		key: 'transpile',
		value: function transpile(code, transforms) {
			_get(ForOfStatement.prototype.__proto__ || Object.getPrototypeOf(ForOfStatement.prototype), 'transpile', this).call(this, code, transforms);
			if (!transforms.dangerousForOf) return;

			// edge case (#80)
			if (!this.body.body[0]) {
				if (this.left.type === 'VariableDeclaration' && this.left.kind === 'var') {
					code.remove(this.start, this.left.start);
					code.appendLeft(this.left.end, ';');
					code.remove(this.left.end, this.end);
				} else {
					code.remove(this.start, this.end);
				}

				return;
			}

			var scope = this.findScope(true);
			var i0 = this.getIndentation();
			var i1 = i0 + code.getIndentString();

			var key = scope.createIdentifier('i');
			var list = scope.createIdentifier('list');

			if (this.body.synthetic) {
				code.prependRight(this.left.start, '{\n' + i1);
				code.appendLeft(this.body.body[0].end, '\n' + i0 + '}');
			}

			var bodyStart = this.body.body[0].start;

			code.remove(this.left.end, this.right.start);
			code.move(this.left.start, this.left.end, bodyStart);

			code.prependRight(this.right.start, 'var ' + key + ' = 0, ' + list + ' = ');
			code.appendLeft(this.right.end, '; ' + key + ' < ' + list + '.length; ' + key + ' += 1');

			var isDeclaration = this.left.type === 'VariableDeclaration';
			var maybeDestructuring = isDeclaration ? this.left.declarations[0].id : this.left;
			if (maybeDestructuring.type !== 'Identifier') {
				var statementGenerators = [];
				var ref = scope.createIdentifier('ref');
				(0, _destructure2.default)(code, function (id) {
					return scope.createIdentifier(id);
				}, function (_ref) {
					var name = _ref.name;
					return scope.resolveName(name);
				}, maybeDestructuring, ref, !isDeclaration, statementGenerators);

				var suffix = ';\n' + i1;
				statementGenerators.forEach(function (fn, i) {
					if (i === statementGenerators.length - 1) {
						suffix = ';\n\n' + i1;
					}

					fn(bodyStart, '', suffix);
				});

				if (isDeclaration) {
					code.appendLeft(this.left.start + this.left.kind.length + 1, ref);
					code.appendLeft(this.left.end, ' = ' + list + '[' + key + '];\n' + i1);
				} else {
					code.appendLeft(this.left.end, 'var ' + ref + ' = ' + list + '[' + key + '];\n' + i1);
				}
			} else {
				code.appendLeft(this.left.end, ' = ' + list + '[' + key + '];\n\n' + i1);
			}
		}
	}]);

	return ForOfStatement;
}(_LoopStatement3.default);

exports.default = ForOfStatement;