'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

var _CompileError = require('../../utils/CompileError.js');

var _CompileError2 = _interopRequireDefault(_CompileError);

var _removeTrailingComma = require('../../utils/removeTrailingComma.js');

var _removeTrailingComma2 = _interopRequireDefault(_removeTrailingComma);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FunctionExpression = function (_Node) {
	_inherits(FunctionExpression, _Node);

	function FunctionExpression() {
		_classCallCheck(this, FunctionExpression);

		return _possibleConstructorReturn(this, (FunctionExpression.__proto__ || Object.getPrototypeOf(FunctionExpression)).apply(this, arguments));
	}

	_createClass(FunctionExpression, [{
		key: 'initialise',
		value: function initialise(transforms) {
			if (this.generator && transforms.generator) {
				throw new _CompileError2.default('Generators are not supported', this);
			}

			this.body.createScope();

			if (this.id) {
				// function expression IDs belong to the child scope...
				this.body.scope.addDeclaration(this.id, 'function');
			}

			_get(FunctionExpression.prototype.__proto__ || Object.getPrototypeOf(FunctionExpression.prototype), 'initialise', this).call(this, transforms);

			var parent = this.parent;
			var methodName = void 0;

			if (transforms.conciseMethodProperty && parent.type === 'Property' && parent.kind === 'init' && parent.method && parent.key.type === 'Identifier') {
				// object literal concise method
				methodName = parent.key.name;
			} else if (transforms.classes && parent.type === 'MethodDefinition' && parent.kind === 'method' && parent.key.type === 'Identifier') {
				// method definition in a class
				methodName = parent.key.name;
			} else if (this.id && this.id.type === 'Identifier') {
				// naked function expression
				methodName = this.id.alias || this.id.name;
			}

			if (methodName) {
				var _iteratorNormalCompletion = true;
				var _didIteratorError = false;
				var _iteratorError = undefined;

				try {
					for (var _iterator = this.params[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
						var param = _step.value;

						if (param.type === 'Identifier' && methodName === param.name) {
							// workaround for Safari 9/WebKit bug:
							// https://gitlab.com/Rich-Harris/buble/issues/154
							// change parameter name when same as method name

							var scope = this.body.scope;
							var declaration = scope.declarations[methodName];

							var alias = scope.createIdentifier(methodName);
							param.alias = alias;

							var _iteratorNormalCompletion2 = true;
							var _didIteratorError2 = false;
							var _iteratorError2 = undefined;

							try {
								for (var _iterator2 = declaration.instances[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
									var identifier = _step2.value;

									identifier.alias = alias;
								}
							} catch (err) {
								_didIteratorError2 = true;
								_iteratorError2 = err;
							} finally {
								try {
									if (!_iteratorNormalCompletion2 && _iterator2.return) {
										_iterator2.return();
									}
								} finally {
									if (_didIteratorError2) {
										throw _iteratorError2;
									}
								}
							}

							break;
						}
					}
				} catch (err) {
					_didIteratorError = true;
					_iteratorError = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion && _iterator.return) {
							_iterator.return();
						}
					} finally {
						if (_didIteratorError) {
							throw _iteratorError;
						}
					}
				}
			}
		}
	}, {
		key: 'transpile',
		value: function transpile(code, transforms) {
			_get(FunctionExpression.prototype.__proto__ || Object.getPrototypeOf(FunctionExpression.prototype), 'transpile', this).call(this, code, transforms);
			if (transforms.trailingFunctionCommas && this.params.length) {
				(0, _removeTrailingComma2.default)(code, this.params[this.params.length - 1].end);
			}
		}
	}]);

	return FunctionExpression;
}(_Node3.default);

exports.default = FunctionExpression;