'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function normalise(str, removeTrailingWhitespace) {

	str = str.replace(/\u00a0/g, '&nbsp;');

	if (removeTrailingWhitespace && /\n/.test(str)) {
		str = str.replace(/\s+$/, '');
	}

	str = str.replace(/^\n\r?\s+/, '') // remove leading newline + space
	.replace(/\s*\n\r?\s*/gm, ' '); // replace newlines with spaces

	// TODO prefer single quotes?
	return JSON.stringify(str);
}

var JSXElement = function (_Node) {
	_inherits(JSXElement, _Node);

	function JSXElement() {
		_classCallCheck(this, JSXElement);

		return _possibleConstructorReturn(this, (JSXElement.__proto__ || Object.getPrototypeOf(JSXElement)).apply(this, arguments));
	}

	_createClass(JSXElement, [{
		key: 'transpile',
		value: function transpile(code, transforms) {
			_get(JSXElement.prototype.__proto__ || Object.getPrototypeOf(JSXElement.prototype), 'transpile', this).call(this, code, transforms);

			var children = this.children.filter(function (child) {
				if (child.type !== 'JSXText') return true;

				// remove whitespace-only literals, unless on a single line
				return (/\S/.test(child.raw) || !/\n/.test(child.raw)
				);
			});

			if (children.length) {
				var c = this.openingElement.end;

				var i = void 0;
				for (i = 0; i < children.length; i += 1) {
					var child = children[i];

					if (child.type === 'JSXExpressionContainer' && child.expression.type === 'JSXEmptyExpression') {
						// empty block is a no op
					} else {
						var tail = code.original[c] === '\n' && child.type !== 'JSXText' ? '' : ' ';
						code.appendLeft(c, ',' + tail);
					}

					if (child.type === 'JSXText') {
						var str = normalise(child.value, i === children.length - 1);
						code.overwrite(child.start, child.end, str);
					}

					c = child.end;
				}
			}
		}
	}]);

	return JSXElement;
}(_Node3.default);

exports.default = JSXElement;