'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

var _CompileError = require('../../utils/CompileError.js');

var _CompileError2 = _interopRequireDefault(_CompileError);

var _regexpuCore = require('regexpu-core');

var _regexpuCore2 = _interopRequireDefault(_regexpuCore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Literal = function (_Node) {
	_inherits(Literal, _Node);

	function Literal() {
		_classCallCheck(this, Literal);

		return _possibleConstructorReturn(this, (Literal.__proto__ || Object.getPrototypeOf(Literal)).apply(this, arguments));
	}

	_createClass(Literal, [{
		key: 'initialise',
		value: function initialise() {
			if (typeof this.value === 'string') {
				this.program.indentExclusionElements.push(this);
			}
		}
	}, {
		key: 'transpile',
		value: function transpile(code, transforms) {
			if (transforms.numericLiteral) {
				if (this.raw.match(/^0[bo]/i)) {
					code.overwrite(this.start, this.end, String(this.value), {
						storeName: true,
						contentOnly: true
					});
				}
			}

			if (this.regex) {
				var _regex = this.regex,
				    pattern = _regex.pattern,
				    flags = _regex.flags;


				if (transforms.stickyRegExp && /y/.test(flags)) throw new _CompileError2.default('Regular expression sticky flag is not supported', this);
				if (transforms.unicodeRegExp && /u/.test(flags)) {
					code.overwrite(this.start, this.end, '/' + (0, _regexpuCore2.default)(pattern, flags) + '/' + flags.replace('u', ''), {
						contentOnly: true
					});
				}
			}
		}
	}]);

	return Literal;
}(_Node3.default);

exports.default = Literal;