'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

var _CompileError = require('../../utils/CompileError.js');

var _CompileError2 = _interopRequireDefault(_CompileError);

var _patterns = require('../../utils/patterns.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Super = function (_Node) {
	_inherits(Super, _Node);

	function Super() {
		_classCallCheck(this, Super);

		return _possibleConstructorReturn(this, (Super.__proto__ || Object.getPrototypeOf(Super)).apply(this, arguments));
	}

	_createClass(Super, [{
		key: 'initialise',
		value: function initialise(transforms) {
			if (transforms.classes) {
				this.method = this.findNearest('MethodDefinition');
				if (!this.method) throw new _CompileError2.default('use of super outside class method', this);

				var parentClass = this.findNearest('ClassBody').parent;
				this.superClassName = parentClass.superClass && (parentClass.superClass.name || 'superclass');

				if (!this.superClassName) throw new _CompileError2.default('super used in base class', this);

				this.isCalled = this.parent.type === 'CallExpression' && this === this.parent.callee;

				if (this.method.kind !== 'constructor' && this.isCalled) {
					throw new _CompileError2.default('super() not allowed outside class constructor', this);
				}

				this.isMember = this.parent.type === 'MemberExpression';

				if (!this.isCalled && !this.isMember) {
					throw new _CompileError2.default('Unexpected use of `super` (expected `super(...)` or `super.*`)', this);
				}
			}

			if (transforms.arrow) {
				var lexicalBoundary = this.findLexicalBoundary();
				var arrowFunction = this.findNearest('ArrowFunctionExpression');
				var loop = this.findNearest(_patterns.loopStatement);

				if (arrowFunction && arrowFunction.depth > lexicalBoundary.depth) {
					this.thisAlias = lexicalBoundary.getThisAlias();
				}

				if (loop && loop.body.contains(this) && loop.depth > lexicalBoundary.depth) {
					this.thisAlias = lexicalBoundary.getThisAlias();
				}
			}
		}
	}, {
		key: 'transpile',
		value: function transpile(code, transforms) {
			if (transforms.classes) {
				var expression = this.isCalled || this.method.static ? this.superClassName : this.superClassName + '.prototype';

				code.overwrite(this.start, this.end, expression, {
					storeName: true,
					contentOnly: true
				});

				var callExpression = this.isCalled ? this.parent : this.parent.parent;

				if (callExpression && callExpression.type === 'CallExpression') {
					if (!this.noCall) {
						// special case – `super( ...args )`
						code.appendLeft(callExpression.callee.end, '.call');
					}

					var thisAlias = this.thisAlias || 'this';

					if (callExpression.arguments.length) {
						code.appendLeft(callExpression.arguments[0].start, thisAlias + ', ');
					} else {
						code.appendLeft(callExpression.end - 1, '' + thisAlias);
					}
				}
			}
		}
	}]);

	return Super;
}(_Node3.default);

exports.default = Super;