'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TemplateLiteral = function (_Node) {
	_inherits(TemplateLiteral, _Node);

	function TemplateLiteral() {
		_classCallCheck(this, TemplateLiteral);

		return _possibleConstructorReturn(this, (TemplateLiteral.__proto__ || Object.getPrototypeOf(TemplateLiteral)).apply(this, arguments));
	}

	_createClass(TemplateLiteral, [{
		key: 'transpile',
		value: function transpile(code, transforms) {
			_get(TemplateLiteral.prototype.__proto__ || Object.getPrototypeOf(TemplateLiteral.prototype), 'transpile', this).call(this, code, transforms);

			if (transforms.templateString && this.parent.type !== 'TaggedTemplateExpression') {
				var ordered = this.expressions.concat(this.quasis).sort(function (a, b) {
					return a.start - b.start || a.end - b.end;
				}).filter(function (node, i) {
					// include all expressions
					if (node.type !== 'TemplateElement') return true;

					// include all non-empty strings
					if (node.value.raw) return true;

					// exclude all empty strings not at the head
					return !i;
				});

				// special case – we may be able to skip the first element,
				// if it's the empty string, but only if the second and
				// third elements aren't both expressions (since they maybe
				// be numeric, and `1 + 2 + '3' === '33'`)
				if (ordered.length >= 3) {
					var _ordered = _slicedToArray(ordered, 3),
					    first = _ordered[0],
					    third = _ordered[2];

					if (first.type === 'TemplateElement' && first.value.raw === '' && third.type === 'TemplateElement') {
						ordered.shift();
					}
				}

				var parenthesise = (this.quasis.length !== 1 || this.expressions.length !== 0) && this.parent.type !== 'TemplateLiteral' && this.parent.type !== 'AssignmentExpression' && this.parent.type !== 'AssignmentPattern' && this.parent.type !== 'VariableDeclarator' && (this.parent.type !== 'BinaryExpression' || this.parent.operator !== '+');

				if (parenthesise) code.appendRight(this.start, '(');

				var lastIndex = this.start;

				ordered.forEach(function (node, i) {
					var prefix = i === 0 ? parenthesise ? '(' : '' : ' + ';

					if (node.type === 'TemplateElement') {
						code.overwrite(lastIndex, node.end, prefix + JSON.stringify(node.value.cooked));
					} else {
						var _parenthesise = node.type !== 'Identifier'; // TODO other cases where it's safe

						if (_parenthesise) prefix += '(';

						code.remove(lastIndex, node.start);

						if (prefix) code.prependRight(node.start, prefix);
						if (_parenthesise) code.appendLeft(node.end, ')');
					}

					lastIndex = node.end;
				});

				if (parenthesise) code.appendLeft(lastIndex, ')');
				code.overwrite(lastIndex, this.end, "", { contentOnly: true });
			}
		}
	}]);

	return TemplateLiteral;
}(_Node3.default);

exports.default = TemplateLiteral;