'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

var _destructure = require('../../utils/destructure.js');

var _destructure2 = _interopRequireDefault(_destructure);

var _patterns = require('../../utils/patterns.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var VariableDeclaration = function (_Node) {
	_inherits(VariableDeclaration, _Node);

	function VariableDeclaration() {
		_classCallCheck(this, VariableDeclaration);

		return _possibleConstructorReturn(this, (VariableDeclaration.__proto__ || Object.getPrototypeOf(VariableDeclaration)).apply(this, arguments));
	}

	_createClass(VariableDeclaration, [{
		key: 'initialise',
		value: function initialise(transforms) {
			this.scope = this.findScope(this.kind === 'var');
			this.declarations.forEach(function (declarator) {
				return declarator.initialise(transforms);
			});
		}
	}, {
		key: 'transpile',
		value: function transpile(code, transforms) {
			var _this2 = this;

			var i0 = this.getIndentation();
			var kind = this.kind;

			if (transforms.letConst && kind !== 'var') {
				kind = 'var';
				code.overwrite(this.start, this.start + this.kind.length, kind, {
					contentOnly: true,
					storeName: true
				});
			}

			if (transforms.destructuring && this.parent.type !== 'ForOfStatement' && this.parent.type !== 'ForInStatement') {
				var c = this.start;
				var lastDeclaratorIsPattern = void 0;

				this.declarations.forEach(function (declarator, i) {
					declarator.transpile(code, transforms);

					if (declarator.id.type === 'Identifier') {
						if (i > 0 && _this2.declarations[i - 1].id.type !== 'Identifier') {
							code.overwrite(c, declarator.id.start, 'var ');
						}
					} else {
						var inline = _patterns.loopStatement.test(_this2.parent.type);

						if (i === 0) {
							code.remove(c, declarator.id.start);
						} else {
							code.overwrite(c, declarator.id.start, ';\n' + i0);
						}

						var simple = declarator.init.type === 'Identifier' && !declarator.init.rewritten;

						var name = simple ? declarator.init.alias || declarator.init.name : declarator.findScope(true).createIdentifier('ref');

						c = declarator.start;

						var statementGenerators = [];

						if (simple) {
							code.remove(declarator.id.end, declarator.end);
						} else {
							statementGenerators.push(function (start, prefix, suffix) {
								code.prependRight(declarator.id.end, 'var ' + name);
								code.appendLeft(declarator.init.end, '' + suffix);
								code.move(declarator.id.end, declarator.end, start);
							});
						}

						var scope = declarator.findScope(false);
						(0, _destructure2.default)(code, function (id) {
							return scope.createIdentifier(id);
						}, function (_ref) {
							var name = _ref.name;
							return scope.resolveName(name);
						}, declarator.id, name, inline, statementGenerators);

						var prefix = inline ? 'var ' : '';
						var suffix = inline ? ', ' : ';\n' + i0;
						statementGenerators.forEach(function (fn, j) {
							if (i === _this2.declarations.length - 1 && j === statementGenerators.length - 1) {
								suffix = inline ? '' : ';';
							}

							fn(declarator.start, j === 0 ? prefix : '', suffix);
						});
					}

					c = declarator.end;
					lastDeclaratorIsPattern = declarator.id.type !== 'Identifier';
				});

				if (lastDeclaratorIsPattern && this.end > c) {
					code.overwrite(c, this.end, '', { contentOnly: true });
				}
			} else {
				this.declarations.forEach(function (declarator) {
					declarator.transpile(code, transforms);
				});
			}
		}
	}]);

	return VariableDeclaration;
}(_Node3.default);

exports.default = VariableDeclaration;