'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Node2 = require('../../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LoopStatement = function (_Node) {
	_inherits(LoopStatement, _Node);

	function LoopStatement() {
		_classCallCheck(this, LoopStatement);

		return _possibleConstructorReturn(this, (LoopStatement.__proto__ || Object.getPrototypeOf(LoopStatement)).apply(this, arguments));
	}

	_createClass(LoopStatement, [{
		key: 'findScope',
		value: function findScope(functionScope) {
			return functionScope || !this.createdScope ? this.parent.findScope(functionScope) : this.body.scope;
		}
	}, {
		key: 'initialise',
		value: function initialise(transforms) {
			this.body.createScope();
			this.createdScope = true;

			// this is populated as and when reassignments occur
			this.reassigned = Object.create(null);
			this.aliases = Object.create(null);

			_get(LoopStatement.prototype.__proto__ || Object.getPrototypeOf(LoopStatement.prototype), 'initialise', this).call(this, transforms);

			if (transforms.letConst) {
				// see if any block-scoped declarations are referenced
				// inside function expressions
				var names = Object.keys(this.body.scope.declarations);

				var i = names.length;
				while (i--) {
					var name = names[i];
					var declaration = this.body.scope.declarations[name];

					var j = declaration.instances.length;
					while (j--) {
						var instance = declaration.instances[j];
						var nearestFunctionExpression = instance.findNearest(/Function/);

						if (nearestFunctionExpression && nearestFunctionExpression.depth > this.depth) {
							this.shouldRewriteAsFunction = true;
							break;
						}
					}

					if (this.shouldRewriteAsFunction) break;
				}
			}
		}
	}, {
		key: 'transpile',
		value: function transpile(code, transforms) {
			var needsBlock = this.type != 'ForOfStatement' && (this.body.type !== 'BlockStatement' || this.body.type === 'BlockStatement' && this.body.synthetic);

			if (this.shouldRewriteAsFunction) {
				var i0 = this.getIndentation();
				var i1 = i0 + code.getIndentString();

				var argString = this.args ? ' ' + this.args.join(', ') + ' ' : '';
				var paramString = this.params ? ' ' + this.params.join(', ') + ' ' : '';

				var functionScope = this.findScope(true);
				var loop = functionScope.createIdentifier('loop');

				var before = 'var ' + loop + ' = function (' + paramString + ') ' + (this.body.synthetic ? '{\n' + i0 + code.getIndentString() : '');
				var after = (this.body.synthetic ? '\n' + i0 + '}' : '') + (';\n\n' + i0);

				code.prependRight(this.body.start, before);
				code.appendLeft(this.body.end, after);
				code.move(this.start, this.body.start, this.body.end);

				if (this.canBreak || this.canReturn) {
					var returned = functionScope.createIdentifier('returned');

					var insert = '{\n' + i1 + 'var ' + returned + ' = ' + loop + '(' + argString + ');\n';
					if (this.canBreak) insert += '\n' + i1 + 'if ( ' + returned + ' === \'break\' ) break;';
					if (this.canReturn) insert += '\n' + i1 + 'if ( ' + returned + ' ) return ' + returned + '.v;';
					insert += '\n' + i0 + '}';

					code.prependRight(this.body.end, insert);
				} else {
					var callExpression = loop + '(' + argString + ');';

					if (this.type === 'DoWhileStatement') {
						code.overwrite(this.start, this.body.start, 'do {\n' + i1 + callExpression + '\n' + i0 + '}');
					} else {
						code.prependRight(this.body.end, callExpression);
					}
				}
			} else if (needsBlock) {
				code.appendLeft(this.body.start, '{ ');
				code.prependRight(this.body.end, ' }');
			}

			_get(LoopStatement.prototype.__proto__ || Object.getPrototypeOf(LoopStatement.prototype), 'transpile', this).call(this, code, transforms);
		}
	}]);

	return LoopStatement;
}(_Node3.default);

exports.default = LoopStatement;